#include "monopoly.h"
#include <sys/stat.h>

GtkWidget *xpm_label_box( GtkWidget *parent, gchar *xpm_filename, int i, gchar *label_text);


void gui_show_dice(int die0, int die1)
{
   char pixpath[50];
        GtkStyle *style;
        GdkBitmap *mask;
        GdkPixmap *dicepixmaps[2];
        int i;
	int dice[2];
	dice[0]=die0; dice[1]=die1;
 
        style = gtk_widget_get_style(window);
        for (i=0; i<=1; i++) {
        printf("removing container...\n");
          gtk_container_remove(GTK_CONTAINER(diceboxes[i]), dicewidgets[i]);
          sprintf(pixpath, "pixmaps/dice%d.xpm", dice[i]);
        printf("pixpath=%s.\n", pixpath);
        printf("Creating diceboxes...\n");
          dicepixmaps[i]=gdk_pixmap_create_from_xpm (window->window, &mask,
                &style->bg[GTK_STATE_NORMAL], pixpath);
        printf("creating dicewidgets...\n");
          dicewidgets[i]=gtk_pixmap_new(dicepixmaps[i], mask);
        gtk_widget_show(dicewidgets[i]);
        printf("adding container...\n");
          gtk_container_add(GTK_CONTAINER(diceboxes[i]), dicewidgets[i]);
       }                                 
}


void do_interact(GtkWidget *widget, char *i)
{
  //printf("do_interact: i is %d.\n", i);
  //printf("do_interact: i is %s.\n", i);
  //to_lower(i); - COREDUMPS!
  if (!strcmp(i, "Shake")) 
    process_interact("shake");
  if (!strcmp(i, "Cash")) 
    process_interact("cash");
  if (!strcmp(i, "Parking")) 
    process_interact("parking");
  if (!strcmp(i, "Quit")) 
    process_interact("quit");
  if (!strcmp(i, "Free")) 
    process_interact("free");
  if (!strcmp(i, "House")) 
    process_interact("house");
  if (!strcmp(i, "Own")) 
    process_interact("own");
  if (!strcmp(i, "Sets")) 
    process_interact("sets");
  if (!strcmp(i, "Taken")) 
    process_interact("taken");
  if (!strcmp(i, "Jail")) 
    process_interact("jail");
  if (!strcmp(i, "Help")) 
    process_interact("help");
}

void gui_show_houses(int loc)
{
  char pixpath[50];
  struct stat statbuf;

  printf("Calling container_remove...\n");
  printf("loc=%d.\n", loc);
  printf("box[loc]=%d.\n", box[loc]);
  printf("button[loc]=%d\n", button[loc]);
  gtk_container_remove(GTK_CONTAINER(button[loc]), box[loc]);
  printf("Done container_remove...\n");
    //button[loc]=gtk_button_new();
    if (Board[loc].NoOfHouses>0) 
      sprintf(pixpath, "pixmaps/group%dh%d.xpm", Board[loc].Colour, Board[loc].NoOfHouses);
    else
      sprintf(pixpath, "pixmaps/group%d.xpm", Board[loc].Colour);
    printf("hello: pixpath=%s\n", pixpath);
    if (stat(pixpath, &statbuf)==-1) {
       sprintf(pixpath, "pixmaps/square%d.xpm", loc);
       if (stat(pixpath, &statbuf)==-1) {
	 printf("Cannot open a pixmap for square %d (Group %d)\n", loc, Board[loc].Colour);
       }
    }
    //printf("hello: Square %d (Group %d): Using %s.\n", loc, Board[loc].Colour, pixpath);
    box[loc]=xpm_label_box(window, pixpath, loc, Board[loc].Name);
    gtk_container_add(GTK_CONTAINER(button[loc]), box[loc]);
    gtk_widget_show(button[loc]);
    gtk_widget_show(box[loc]);
}

void gui_show_owns_street(int location, int player)
{
    GtkWidget *pixmapwid;
    GdkPixmap *pixmap;
    GdkBitmap *mask;
    GtkStyle *style;
    char xpm_filename[50];
    int x,y;

	printf("Player %d now owns %s\n", player, Board[location].Name);
	sprintf(note, "Player %d now owns %s.\n", player, Board[location].Name);
	notify(note);

    if ( (location<20) && (location>10) || (location>30) )
      sprintf(xpm_filename, "pixmaps/p%dvert.xpm", player);
    else
      sprintf(xpm_filename, "pixmaps/p%dhoriz.xpm", player);
    /* Get the style of the button to get the background color. */
    style = gtk_widget_get_style(window);              
    /* Now on to the xpm stuff */
    pixmap = gdk_pixmap_create_from_xpm (window->window, &mask,
                                         &style->bg[GTK_STATE_NORMAL],
                                         xpm_filename);
    pixmapwid = gtk_pixmap_new (pixmap, mask);
    x=xloc(location); y=yloc(location);
    if (location<10) { y-=05; x+=2; }
    else if (location<20) { x+=85; y+=2; }
    else if (location<30) { y+=85; x+=2; }
    else { x-=05; y+=2; }
    gtk_fixed_put(GTK_FIXED(fixed), pixmapwid, x,y);
    gtk_widget_show(pixmapwid);
}

gint kill_interact_dialog(GtkWidget *widget, GMainLoop *loop)
{
        printf("Killing Dialog...\n");
        g_main_quit(loop);
        return (FALSE);
}


void add_interact_dialog()
{
  GtkWidget *dialogbutton[12];
  GtkWidget *mydialog;
  GMainLoop *loop;
  int i;
  char buf[200];
  char *msg[12] = { "Help", "Taken", "Cash","Quit","Free","House","Shake","Own","Parking","Sets", "Mortgage", "Jail" };

  loop=g_main_new(FALSE);

	interact_dialog=gtk_hbox_new(FALSE, 0);
  gtk_fixed_put(GTK_FIXED(fixed), interact_dialog, 100,250);
	sprintf(buf, "%s - Main Dialog", Names[MyPlayerNum]);
	//gtk_window_set_title(GTK_WINDOW(interact_dialog), buf);
	for (i=0; i<=11; i++) {
	  dialogbutton[i] = gtk_button_new_with_label (msg[i]);
	  gtk_box_pack_start (GTK_BOX (interact_dialog),dialogbutton[i], TRUE, TRUE, 0); 
   gtk_signal_connect (GTK_OBJECT (dialogbutton[i]), "clicked", GTK_SIGNAL_FUNC (do_interact), msg[i]); 
   if (i==6) 
     gtk_signal_connect (GTK_OBJECT (dialogbutton[i]), "clicked", GTK_SIGNAL_FUNC (kill_interact_dialog), loop); 
	  gtk_widget_show (dialogbutton[i]);
	}
     //gtk_signal_connect (GTK_OBJECT (interact_dialog), "destroy", GTK_SIGNAL_FUNC (gtk_main_quit), NULL); 
     //gtk_signal_connect (GTK_OBJECT (interact_dialog), "destroy", GTK_SIGNAL_FUNC (gtk_main_quit), NULL); 
	gtk_widget_show(interact_dialog);
        g_main_run(loop); 
	g_main_destroy(loop); 
        gtk_widget_destroy(interact_dialog); 

	
}

char text_getYN(char *msg, char *Y, char *N)
{
  char c, y, n;
	//y=toupper(Y[0]);
	//n=toupper(N[0]);
	y=Y[0]; n=N[0];
  c='#';
  while ((c!=y) && (c!=n)) {
	printf("%s: %s / %s (%c/%c): ", msg, Y, N, y, n);
	c=toupper(fgetc(stdin));
	// Skip the \n ...
  }
  fgetc(stdin);
  return (y==c);
}

void do_guiYN(GtkWidget *widget, char *x)
{
	printf("The button you pressed was '%s'.\n", x);
	strcpy(YN, x);
}

int xloc(int x)
{
  if (x<10) return ((10-x)*56)+40;
  if (x<21) return 10;
  if (x<30) return ((x-20)*56)+40;
  return 600;
}

int yloc(int y)
{
  if (y<11) return 600;
  if (y<20) return ((20-y)*56)+40;
  if (y<31) return 10;
  return ((y-30)*56)+40;
}

void gui_update_cash()
{ 
  int i;
  char msg[50];

  for (i=1; i<=NoOfPlayers; i++) {
    sprintf(msg, "\n%d", Cash[i]);
    gtk_text_insert(GTK_TEXT(cashtxt[i]), fixed_font, NULL, NULL, msg, strlen(msg));     
  }
}

void move_pointer(int player, int loc)
{
  char msg[50];
  int x,y, i;

  printf("move_pointer: loc=%d.\n", loc);
  printf("move_pointer: From %d.\n", Location[player]);
  if (loc==Location[player]) 
	printf("*********************\n   Already there!\n***********\n");
  sprintf(msg, "\nP%d: %s", player, Board[loc].Name);
  gtk_text_insert(GTK_TEXT(loctxt[player]), fixed_font, NULL, NULL, msg, strlen(msg));
// Do this at more sensible times, please!
	gui_update_cash();
  
  i=Location[player];
  i=loc;
  //while (i!=loc) {
    //i++;
    if (i==40) i=0;
	printf("****************************    i=%d.\n");
    x=xloc(i); y=yloc(i);
    if (i<11) { x+=10*player; y+=90; }
    else if (i<21) { x=0; y+=10*player; }
    else if (i<31) { x+=10*player; y=0; }
    else { x+=90; y+=10*player; }
    gtk_fixed_move(GTK_FIXED(fixed), GTK_WIDGET(pixmapwid[player]), x, y);
	// We only send this info out if we're doing the moving - 
	// otherwise, everyone keeps telling everyone else!
      //if (MyPlayerNum==player) 
	//send_structured_packet(LOCATION, player, i, "");
    //sleep(1);
  //}
}

void gui_getYN(char *msg, char *Y, char *N)
{
  GtkWidget *dialogbutton[2];
  GtkWidget *mydialog;
  GtkWidget *label;
  GMainLoop *loop;
  char buf[50];
  int i;

  loop=g_main_new(FALSE);

	mydialog=gtk_dialog_new();
	sprintf(buf, "Question: %s.", Names[Player]);
        gtk_window_set_title(GTK_WINDOW(mydialog), buf);
	gtk_window_set_position(GTK_WINDOW(mydialog), GTK_WIN_POS_CENTER);
        label=gtk_label_new(msg);
	//gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, msg, strlen(msg));
    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_FILL);
    gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
	  gtk_box_pack_start (GTK_BOX (GTK_DIALOG(mydialog)->vbox),label, FALSE, TRUE, 0); 
	gtk_widget_show(label);
	  dialogbutton[0] = gtk_button_new_with_label (Y);
	  gtk_box_pack_start (GTK_BOX (GTK_DIALOG(mydialog)->action_area),dialogbutton[0], TRUE, TRUE, 0); 
   gtk_signal_connect (GTK_OBJECT (dialogbutton[0]), "clicked", GTK_SIGNAL_FUNC (do_guiYN), Y); 
   gtk_signal_connect (GTK_OBJECT (dialogbutton[0]), "clicked", GTK_SIGNAL_FUNC (kill_interact_dialog), loop); 
	  gtk_widget_show (dialogbutton[0]);
	  dialogbutton[1] = gtk_button_new_with_label (N);
	  gtk_box_pack_start (GTK_BOX (GTK_DIALOG(mydialog)->action_area),dialogbutton[1], TRUE, TRUE, 0); 
   gtk_signal_connect (GTK_OBJECT (dialogbutton[1]), "clicked", GTK_SIGNAL_FUNC (do_guiYN), N); 
   gtk_signal_connect (GTK_OBJECT (dialogbutton[1]), "clicked", GTK_SIGNAL_FUNC (kill_interact_dialog), loop); 
	  gtk_widget_show (dialogbutton[1]);

     //gtk_signal_connect (GTK_OBJECT (mydialog), "destroy", GTK_SIGNAL_FUNC (gtk_main_quit), NULL); 
     //gtk_signal_connect (GTK_OBJECT (mydialog), "destroy", GTK_SIGNAL_FUNC (gtk_main_quit), NULL); 
 printf("widget_show...\n");
	gtk_widget_show(mydialog);
        g_main_run(loop); 
	g_main_destroy(loop); 
        gtk_widget_destroy(mydialog); 
printf("YN is %s \n", YN);
//return YN;
}



void gui_house_get_value(GtkWidget *widget, GtkSpinButton *spin)
{
  char buf[32];
  int *i;
  int j, proposed, res;

/*	Note that we are cheating a bit here; we are supposed to
*	pass a pointer to some real data in *i; instead, i itself
*	is the data. So i==1, doesn't refer to some data stored
*	at 0x0001, but to Old Kent Road.
*	This just saves some space and some hassle.
*	We've wasted enough of both elsewhere in the code!!!
*/
	i=gtk_object_get_user_data (GTK_OBJECT (widget)); 
//	printf("i=%d.\n", i);
	j=(int)i;	// Give me a "nice" variable!
	strcpy(buf, Board[j].Name);
	printf("Street=%s.\n", buf);
    sprintf (buf, "%d", gtk_spin_button_get_value_as_int (spin));
	printf("New NoOfHouses=%s.\n", buf);
	
	/* Check that everything's legal ... */
	/* At the moment no checks are done, and no money changes hands. */
	/* Note that we can always put the spinner back to its default   *
	*  because it is stored in Board[j].NoOfHouses until we OK a change. */
	
        proposed=atoi(buf);
	res=houses_okay(j, proposed);
 	if (res==0) {

	  if (Board[j].NoOfHouses > proposed) {
		/* They're selling a house */
		Cash[Player]+=Board[j].CostofHouses/2;
	  }
	  else {
		/* They're buying a house */
		Cash[Player]-=Board[j].CostofHouses;
	  }
	  send_structured_packet(CASH, Player, Cash[Player], "");
	gui_update_cash();
	  Board[j].NoOfHouses=proposed;
	  send_structured_packet(HOUSE, j, Board[j].NoOfHouses, "");
	  gui_show_houses(j);
	}
	else {
	  printf("Houses_Okay returned %d.\n", res);
	  gtk_spin_button_set_value(spin, Board[j].NoOfHouses);
	}
}                          

GtkWidget *house_box(int i, GtkWidget *dialog)
{ 
  GtkWidget *hbox, *spinner, *label;
  GtkAdjustment *adj;

  hbox=gtk_hbox_new(FALSE, 5);
  //gtk_box_pack_start(GTK_BOX(dialog), hbox, TRUE, TRUE, 5);
  label = gtk_label_new (Board[i].Name);
  //gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0); 
  adj = (GtkAdjustment *) gtk_adjustment_new (Board[i].NoOfHouses, 0, 5, 1, 1, 5);  
	//value, lower, upper, increment, page_increment, page_size
	gtk_object_set_user_data(GTK_OBJECT(adj), (int *)i);
  spinner = gtk_spin_button_new (adj, 0, 0); 
  gtk_signal_connect (GTK_OBJECT (adj), "value_changed",  
	GTK_SIGNAL_FUNC (gui_house_get_value), spinner);
		
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinner), TRUE);   
  gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spinner),  GTK_SHADOW_OUT);        
  gtk_box_pack_start (GTK_BOX (hbox), spinner, FALSE, TRUE, 0);  

  gtk_widget_show(label);
  gtk_widget_show(spinner);
  return (hbox);
}

void gui_buy_sell_houses()
{
  GtkWidget *housedialog, *okbutton;
  GtkWidget *frame; 
  GtkWidget *main_vbox, *vbox[8];
  GtkWidget *hbox[4];
  GMainLoop *loop;
  int CanBuy[8];
  int i, skip;
  int j=0;
  
  for (i=0; i<=7; i++) CanBuy[i]=0;
  for (i=0; i<40; i++) {
	if ( (own_set(Player, i)==0) && (Board[i].Colour>=9) && (CanBuy[j]==0) && (skip!=Board[i].Colour)) {
	  CanBuy[j++]=i;
	  skip=Board[i].Colour;
        }
  }
  printf("You own %d valid sets.\n", j);
  if (j>0) {
    loop=g_main_new(FALSE);
    housedialog=gtk_dialog_new();
	gtk_window_set_position(GTK_WINDOW(housedialog), GTK_WIN_POS_CENTER);
    main_vbox=gtk_vbox_new(FALSE, 5);
    //gtk_container_add(GTK_CONTAINER(housedialog), main_vbox);
        gtk_box_pack_start (GTK_BOX (GTK_DIALOG(housedialog)->action_area), main_vbox, TRUE, TRUE, 0);
	printf("Not Calling gtk_container_add...\n");
	printf("Calling set_title...\n");
    gtk_window_set_title(GTK_WINDOW(housedialog), "Buy / Sell Houses");
    for (i=0; i<=7; i++) {
      if (CanBuy[i]>0) { 
 	char colname[50];
	sprintf(colname, "%s: Cost of Houses=%d", colour_name(Board[CanBuy[i]].Colour), Board[CanBuy[i]].CostofHouses);
	printf("Setting frame...%s\n", colname);
        frame=gtk_frame_new(colname);
 gtk_box_pack_start (GTK_BOX (main_vbox), frame, TRUE, TRUE, 0); 
	vbox[i]=gtk_vbox_new(FALSE, 5);
	gtk_container_add(GTK_CONTAINER(frame), vbox[i]);
	hbox[0]=house_box(CanBuy[i], vbox[i]);
	gtk_container_add(GTK_CONTAINER(vbox[i]), hbox[0]);
	gtk_widget_show(hbox[0]);
	if (Board[CanBuy[i]].OneOtherInSet!=0) {
	  hbox[1]=house_box(Board[CanBuy[i]].OneOtherInSet, vbox[i]);
	  gtk_container_add(GTK_CONTAINER(vbox[i]), hbox[1]);
	gtk_widget_show(hbox[1]);
	}
	if (Board[CanBuy[i]].TwoOtherInSet!=0) {
	  hbox[2]=house_box(Board[CanBuy[i]].TwoOtherInSet, vbox[i]);
	gtk_widget_show(hbox[2]);
	  gtk_container_add(GTK_CONTAINER(vbox[i]), hbox[2]);
	}
	if (Board[CanBuy[i]].ThirdOtherInSet!=0) {
 	  hbox[3]=house_box(Board[CanBuy[i]].ThirdOtherInSet, vbox[i]);
	gtk_widget_show(hbox[3]);
	  gtk_container_add(GTK_CONTAINER(vbox[i]), hbox[3]);
	}
	// Add buttons, etc for this, too.
	gtk_widget_show(frame);
	gtk_widget_show(vbox[i]);
      }
	gtk_widget_show(main_vbox);
    }
	okbutton=gtk_button_new_with_label("Close");
/*
  gtk_signal_connect_object (GTK_OBJECT (okbutton), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (housedialog));          
*/
     gtk_signal_connect (GTK_OBJECT (okbutton), "clicked", GTK_SIGNAL_FUNC (kill_interact_dialog), loop); 
        gtk_box_pack_start (GTK_BOX (main_vbox), okbutton, FALSE, FALSE, 0);
	gtk_widget_show(okbutton);
	        gtk_widget_show(housedialog);
        g_main_run(loop);
        g_main_destroy(loop);
        gtk_widget_destroy(housedialog);      
  } // j>0
}


char getYN(char *msg, char *Y, char *N)
{
  char res;
	if (text)
		res=text_getYN(msg, Y, N);
	else {
		gui_getYN(msg, Y, N);
		res=(!strcmp(YN, Y)); 
	}
	return res;
}

int getnum(char *msg)
{
  char s[5];
  int res=0;
  int fail=0;
  while(res==0) {
	if (fail==1) fgetc(stdin);
	printf("%s ", msg);
	fgets(s, 4, stdin);
	res=isdigit(s[0]);
	fail=1;
  }
  res=atoi(s);
  return res;
}

void gui_show_text(char *titlebar, char *buf, int len, int x, int y)
{
/*
	KILLME
	THIS WHOLE LOT IS JUST COMMENTED OUT BECAUSE I'M SICK 
	OF THESE REMINDERS.
  GtkWidget *mywin;
  GtkWidget *button;
  GtkWidget *vbox;
  GtkWidget *mytext;

	mywin=gtk_window_new(FALSE);
	gtk_widget_set_usize(mywin, x, y);
	gtk_window_set_position(GTK_WINDOW(mywin), GTK_WIN_POS_CENTER);
	gtk_window_set_title(GTK_WINDOW(mywin), titlebar);
	button=gtk_button_new_with_label("Dismiss");
	mytext=gtk_text_new(NULL, NULL);
        vbox=gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(mywin), vbox);
	gtk_widget_show(vbox);

	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, len);
        gtk_text_set_word_wrap (GTK_TEXT (mytext), TRUE);

	gtk_box_pack_start(GTK_BOX(vbox), mytext, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked", 
		(GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (mywin));
	gtk_widget_show(mytext);
	gtk_widget_show(button);
	gtk_widget_show(mywin);
*/
}

void gui_buy_sell_mortgage()
{
	sprintf(note, "Mortgages unimplemented.\n");
	notify(note);
	gui_show_text("Unimplemented", note, strlen(note), 200, 70);
}

int audit(int player)
{
  int fingers=0; // used for calculations
  int i,j;

  if (Cash[player]>0) fingers=Cash[player];
  fingers+=OutOfJailFree[player]*50;
  for (i=0; i<40; i++) {
	if ((Owns[i]==player) && (Board[i].Mortgaged==0)) {
	  for (j=Board[i].NoOfHouses; j>0; j--)
		fingers+=Board[i].CostofHouses/2;
        }
  }
  
    for (i=0; i<40; i++) {
      if (Owns[i]==player) 
         if (Board[i].Mortgaged==0)
	   fingers+=Board[i].Cost;
         else
	   fingers+=Board[i].MortgageValue;
      } //for

  return fingers;
}

int receive_structured_packet(gpointer data, gint source, GdkInputCondition condition)
{
  int res;
  int pkttype, index, val, i;
  int p;
  structured_packet *sp;

  sp=(structured_packet*)malloc(sizeof(structured_packet));
  res=0;
  if (MyPlayerNum==Master) p=Player; else p=Master;
  //printf("Player=%d, MyPlayerNum=%d, Master=%d, p=%d.\n", Player, MyPlayerNum, Master, p);

  //printf("receive_structured_packet calling receive_packet...\n");
  receive_packet(sp, sizeof(structured_packet), p);
  //if (DEBUG==1) 
  printf("recieved packet: %d[%d]=%d (%s)\n", sp->pkttype, sp->index, sp->val, sp->sval);
  if (MyPlayerNum==Master)
  {
	/* We must now forward this to all but the one we got it from... */
	send_structured_packet(sp->pkttype, sp->index, sp->val, sp->sval);
  }
  switch (sp->pkttype) {
        case PLAYER: Player=sp->val; res=sp->val; 
	if ((MyPlayerNum==Master) && (text==0)) { 
	  gtk_input_remove(interrupt); 
	  interrupt=add_input(Player);
        }
	break;
        //case BOARD: Board[sp->index]=sp->val; break; /* Can we use this?! */
        case CASH: Cash[sp->index]=sp->val; printf("Cash[%d]=%d.\n", sp->index, sp->val);
		if (text==0) gui_update_cash(); break;
        case HOUSE: Board[sp->index].NoOfHouses=sp->val; 
	sprintf(note, "Board[%d].NoOfHouses=%d.\n", sp->index, sp->val); notify(note);
	if (text==0) gui_show_houses(sp->index);
	break;
        case OWNS: Owns[sp->index]=sp->val; if (text==0) gui_show_owns_street(sp->index, sp->val); break;
        case FREEPARKING: FreeParking=sp->val; 
	sprintf(note, "Free Parking now worth %d.\n", sp->val); notify(note); break;
        case JAIL: InJail[sp->index]=sp->val; 
	sprintf(note, "InJail[%d]=%d.\n", sp->index, sp->val); notify(note); 	
	gui_show_text("Player in Jail", note, strlen(note), 200, 70);
	break;
        case LOCATION: move_player(sp->index, sp->val); sprintf(note, "Player %d is on %s.\n", sp->index, Board[sp->val].Name); notify(note); break;
        case MORTGAGED: Board[sp->index].Mortgaged=sp->val; 
	sprintf(note, "Square %d Mortgaged=%d.\n", sp->index, sp->val); notify(note); break;
        case QUIT: Quit[sp->index]=1; printf("Player %d Quit.\n", sp->index); break;
        case CHAT: printf("Player %d says '%s' to Player %d.\n", sp->index, sp->sval, sp->val); break;
	case TEST: printf("Received test...\n");
		   printf("pkttype=%d, index=%d, val=%d, sval=%s\n", sp->pkttype, sp->index, sp->val, sp->sval);
		   break;
	case DICE: if (text==0) gui_show_dice(sp->index, sp->val); break;
	case INFO: if (text==0) { 
		sprintf(note, "%s: Information", Names[Player]);
		notify(sp->sval);
		//gui_show_text(note, sp->sval, strlen(sp->sval), 300, 200);
		}
		 break;
        default: printf("ERROR: Received malformed structured packet...\n"); 
		 printf("pkttype=%d, index=%d, val=%d, sval=%s\n", sp->pkttype, sp->index, sp->val, sp->sval);
		 break;
  }

  if ((sp->pkttype==PLAYER) && (res==MyPlayerNum) && (text==0)) play_game();
  free(sp);
  return res;
}

int add_input(int p)
{
      return gdk_input_add(mysocket[p], GDK_INPUT_READ, GTK_SIGNAL_FUNC(receive_structured_packet), 0);
}

void text_show_street(int loc)
{
  Square s;

  s=Board[loc];

  if (s.Colour > 7)
  {                                                                                                                   printf(" %-22s", s.Name);
        printf(" (%s).\n Owned by ", colour_name(s.Colour));
        if (Owns[loc]==0) printf("nobody.\n"); else printf("Player %d.\n", Owns[loc]);
        printf("RENT - SITE ONLY         %5d\n", s.Rent[0]);
        printf(" \"   - with 1 house      %5d\n", s.Rent[1]);
        printf(" \"   - with 2 houses     %5d\n", s.Rent[2]);
        printf(" \"   - with 3 houses     %5d\n", s.Rent[3]);
        printf(" \"   - with 4 houses     %5d\n", s.Rent[4]);
        printf("RENT WITH HOTEL          %5d\n", s.Rent[5]);
        printf("\nIf a player owns all the sites of any\n");
        printf(" colour group, the rent is doubled on\n");
        printf("  unimproved sites in that group.\n\n");
        printf("Cost of houses           %5d\n", s.CostofHouses);
        printf("Cost of hotels           %5d plus\n", s.CostofHouses);
        printf("                            4 houses\n");
        printf("Mortgage value of site   %5d\n", s.MortgageValue);
        printf("Face value of site       %5d\n", s.Cost);
        printf("\nNumber of houses currently on the street: %d.\n", s.NoOfHouses);
  }
  else
    printf("%s\n", s.Name);
}                           

void gui_show_street(int loc)
{
  GtkWidget *button;
  GtkWidget *mytext;
  GtkWidget *mywin;
  GtkWidget *vbox;
  char buf[200];
  Square s;

  s=Board[loc];

  if (s.Colour > 7) {
	mywin=gtk_window_new(FALSE);
	gtk_widget_set_usize(mywin, 500, 400);
	gtk_window_set_title(GTK_WINDOW(mywin), s.Name);
	button=gtk_button_new_with_label("Dismiss");
	mytext=gtk_text_new(NULL, NULL);
        vbox=gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(mywin), vbox);
	gtk_widget_show(vbox);


        sprintf(buf, " (%s).\n Owned by ", colour_name(s.Colour));
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        if (Owns[loc]==0) 
	  sprintf(buf, "nobody.\n"); 
	else 
	  sprintf(buf,"Player %d.\n", Owns[loc]);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, "RENT - SITE ONLY         %5d\n", s.Rent[0]);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, " \"   - with 1 house      %5d\n", s.Rent[1]);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, " \"   - with 2 houses     %5d\n", s.Rent[2]);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, " \"   - with 3 houses     %5d\n", s.Rent[3]);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, " \"   - with 4 houses     %5d\n", s.Rent[4]);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, "RENT WITH HOTEL          %5d\n", s.Rent[5]);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, "\nIf a player owns all the sites of any\n");
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, " colour group, the rent is doubled on\n");
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, "  unimproved sites in that group.\n\n");
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, "Cost of houses           %5d\n", s.CostofHouses);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, "Cost of hotels           %5d plus\n", s.CostofHouses);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, "                            4 houses\n");
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, "Mortgage value of site   %5d\n", s.MortgageValue);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, "Face value of site       %5d\n", s.Cost);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        sprintf(buf, "\nNumber of houses currently on the street: %d.\n", s.NoOfHouses);
	gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));



	gtk_box_pack_start(GTK_BOX(vbox), mytext, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked", 
		(GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (mywin));
	gtk_widget_show(mytext);
	gtk_widget_show(button);
	gtk_widget_show(mywin);
  }
}

int text_what_do_i_own(int player, int verbose)
{
int i, j=0;

        if (verbose==1) {
          printf("                                                  Mortgage  No of\n");
          printf(" p   Street Name               Colour        Cost    Value    Houses  Rent\n");
          printf("    ------------------   --------------------------------------------------\n");
        }

        for (i=0; i<40; i++)
          if (Owns[i]==player || ((player==-1)&&Owns[i]>0)) {
                if ( (verbose==1) && (Board[i].Colour>=7) )
                {
                   printf("%2d   %-25s %-12s  %4d  %4d       %d     %4d\n", Owns[i],
                        Board[i].Name, colour_name(Board[i].Colour), Board[i].Cost,
                        Board[i].MortgageValue, Board[i].NoOfHouses, get_rent(i));
                }
                j++;
          }
return j;
}                          

int gui_what_do_i_own(int player, int verbose)
{
  GtkWidget *mywin;
  int i, j=0;
  GtkWidget *button;
  GtkWidget *mytext;
  GtkWidget *vbox;
  char buf[200];
  Square s;

  s=Board[Location[player]];

	sprintf(buf, "Streets Owned by %s", Names[player]);
	if (player==-1)
          sprintf(buf, "List of All Owned Streets");
	if (player==0)
          sprintf(buf, "List of All Free Streets");
	mywin=gtk_window_new(FALSE);
	gtk_widget_set_usize(mywin, 800, 500);
	gtk_window_set_title(GTK_WINDOW(mywin), buf);
	button=gtk_button_new_with_label("Dismiss");
	mytext=gtk_text_new(NULL, NULL);
        vbox=gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(mywin), vbox);
	gtk_widget_show(vbox);


        if (verbose==1) {
          sprintf(buf, "                                                  Mortgage    No of\n");
	  gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
          sprintf(buf, " p   Street Name               Colour        Cost    Value    Houses  Rent\n");
	  gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
          sprintf(buf, "    ------------------   --------------------------------------------------\n");
	  gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
        }

        for (i=0; i<40; i++)
          if (Owns[i]==player || ((player==-1)&&Owns[i]>0)) {
                if ( (verbose==1) && (Board[i].Colour>=7) )
                {
                   sprintf(buf, "%2d   %-25s %-12s  %4d  %4d       %d     %4d\n", Owns[i],
                        Board[i].Name, colour_name(Board[i].Colour), Board[i].Cost,
                        Board[i].MortgageValue, Board[i].NoOfHouses, get_rent(i));
		   gtk_text_insert(GTK_TEXT(mytext), fixed_font, NULL, NULL, buf, strlen(buf));
                }
                j++;
          }

      if (verbose==1) {
	gtk_box_pack_start(GTK_BOX(vbox), mytext, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked", 
		(GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (mywin));
	gtk_widget_show(mytext);
	gtk_widget_show(button);
	gtk_widget_show(mywin);
      }
  return j;
}

gint delete_event( GtkWidget *widget, GdkEvent  *event, gpointer   data )
{
  return (TRUE);
}

void destroy( GtkWidget *widget, gpointer   data )
{
         gtk_main_quit();
}

void showinfo(GtkWidget *widget, int *i)
{
  printf("Your button is %s (%d)\n", Board[*i].Name, *i);
  show_street(*i);
}


GtkWidget *xpm_label_box( GtkWidget *parent, gchar *xpm_filename, int i, gchar *label_text)
{
    GtkWidget *box1;
    GtkWidget *label;
    GtkWidget *pixmapwid;
    GdkPixmap *pixmap;
    GdkBitmap *mask;
    GtkStyle *style;

    /* Create box for xpm and label */
    if ( (i<11) || ((i>=20) && (i<=30)) )
      box1 = gtk_vbox_new (FALSE, 0);
    else
      box1 = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (box1), 0);

    /* Get the style of the button to get the background color. */
    style = gtk_widget_get_style(parent);              
    /* Now on to the xpm stuff */
    pixmap = gdk_pixmap_create_from_xpm (parent->window, &mask,
                                         &style->bg[GTK_STATE_NORMAL],
                                         xpm_filename);
    pixmapwid = gtk_pixmap_new (pixmap, mask);

    /* Create a label for the button */
/*
    label = gtk_text_new (FALSE, FALSE);
    gtk_text_insert(GTK_TEXT(label), small_font, NULL, NULL, label_text, strlen(label_text));
    //gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_FILL);
    gtk_text_set_word_wrap (GTK_TEXT (label), TRUE);
    gtk_widget_set_usize (label, 40, 25);    
*/
   /*  Pack the pixmap and label into the box */
    if ( (i<11) || ((i>=20) && (i<=30)) ) {
      gtk_box_pack_start (GTK_BOX (box1), pixmapwid, TRUE, TRUE, 0);
      //gtk_box_pack_start (GTK_BOX (box1), label, FALSE, TRUE, 0);
    }
    else {
      gtk_box_pack_start (GTK_BOX (box1), pixmapwid, TRUE, TRUE, 0);
     // gtk_box_pack_start (GTK_BOX (box1), label, FALSE, TRUE, 0);
    }
    gtk_widget_show(pixmapwid);
    //gtk_widget_show(label);

    return(box1);                               
}


GtkWidget *add_text_box(int x, int y, int xdim, int ydim)
{
   GtkWidget *w;

   w=gtk_text_new(NULL, NULL);
   gtk_fixed_put(GTK_FIXED(fixed), w, x, y);
   gtk_widget_set_usize (w, xdim, ydim);    
   gtk_widget_show(w);
   gtk_widget_realize(w);

   return w;
}

void gui_start(int argc, char **argv)
{
  struct stat statbuf;
  GtkTooltips *tooltips;
  char msg[50];
  char pixpath[50];
  char xpm_filename[50];
  GdkPixmap *playerarrow, *dicepixmaps[2];
  GtkStyle *style;
  GdkBitmap *mask;
  int i;
  int x,y;
  int j[40];

  gtk_init(&argc, &argv);
   small_font=gdk_font_load ("-*-new century schoolbook-medium-r-normal-*-8-*-*-*-*-*-*-*"); 
   fixed_font = gdk_font_load ("-misc-fixed-medium-r-*-*-*-140-*-*-*-*-*-*"); 
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_usize(window, 700, 700);
  gtk_window_set_title(GTK_WINDOW (window), argv[1]);
  gtk_container_set_border_width (GTK_CONTAINER (window), 0);
   gtk_signal_connect (GTK_OBJECT (window), "destroy",
                      GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
  fixed = gtk_fixed_new();       
  gtk_container_add(GTK_CONTAINER(window), fixed);         
  gtk_widget_show(fixed);      
  gtk_widget_realize(window);  
  tooltips=gtk_tooltips_new();
  for (i = 0 ; i < 40 ; i++) {
    /* Creates a new button with the label "Press me" */
    sprintf(msg, "%s", Board[i].Name);
    //sprintf(msg, "%d", i);
   // button[i] = gtk_button_new_with_label (msg);
    button[i]=gtk_button_new();
    sprintf(pixpath, "pixmaps/group%d.xpm", Board[i].Colour);
    if (stat(pixpath, &statbuf)==-1) {
       sprintf(pixpath, "pixmaps/square%d.xpm", i);
       if (stat(pixpath, &statbuf)==-1) {
	 printf("Cannot open a pixmap for square %d (Group %d)\n", i, Board[i].Colour);
       }
    }
    //printf("Square %d (Group %d): Using %s.\n", i, Board[i].Colour, pixpath);
    box[i]=xpm_label_box(window, pixpath, i, Board[i].Name);
    gtk_container_add(GTK_CONTAINER(button[i]), box[i]);
    gtk_tooltips_set_tip(tooltips, button[i], msg, NULL);
    j[i]=i;
 
  x=xloc(i); y=yloc(i);
   gtk_signal_connect (GTK_OBJECT (button[i]), "clicked", GTK_SIGNAL_FUNC (showinfo), &j[i]); 
    gtk_fixed_put (GTK_FIXED (fixed), button[i], x,y);   
    gtk_widget_show (button[i]);  
    gtk_widget_show(box[i]);
  }
  //add_interact_dialog();
  for (i=1; i<=NoOfPlayers; i++) {
//	playerarrow[i]=gtk_fixed_new();
	sprintf(xpm_filename, "pixmaps/player%d.xpm", i);
	   style = gtk_widget_get_style( window );
	printf("fixed->window=%d.\n", window->window);
  playerarrow = gdk_pixmap_create_from_xpm(window->window, &mask, &style->bg[GTK_STATE_NORMAL], xpm_filename);
    pixmapwid[i] = gtk_pixmap_new (playerarrow, mask);
	gtk_fixed_put(GTK_FIXED(fixed), GTK_WIDGET(pixmapwid[i]), xloc(0)+10*i, yloc(0)+90);
	gtk_widget_show(GTK_WIDGET(pixmapwid[i]));
	sprintf(msg, "%s", Names[i]);
	gtk_tooltips_set_tip(tooltips, GTK_WIDGET(pixmapwid[i]), msg, NULL);
	//gtk_fixed_put(GTK_FIXED(playerarrow[i]), PICTURE_OF_ARROW, x, y);
  }

  diceboxes[0]=gtk_hbox_new(FALSE, 0);
  diceboxes[1]=gtk_hbox_new(FALSE, 0);


  dicepixmaps[0]=gdk_pixmap_create_from_xpm(window->window, &mask, &style->bg[GTK_STATE_NORMAL], "pixmaps/dice0.xpm"); 
  dicepixmaps[1]=gdk_pixmap_create_from_xpm(window->window, &mask, &style->bg[GTK_STATE_NORMAL], "pixmaps/dice0.xpm"); 
  dicewidgets[0]=gtk_pixmap_new(dicepixmaps[0], mask);
  dicewidgets[1]=gtk_pixmap_new(dicepixmaps[1], mask);
  gtk_fixed_put(GTK_FIXED(fixed), GTK_WIDGET(diceboxes[0]), 500, 100);
  gtk_fixed_put(GTK_FIXED(fixed), GTK_WIDGET(diceboxes[1]), 550, 100);
	gtk_container_add(GTK_CONTAINER(diceboxes[0]), dicewidgets[0]);
	gtk_container_add(GTK_CONTAINER(diceboxes[1]), dicewidgets[1]);
	gtk_widget_show(GTK_WIDGET(dicewidgets[0]));
	gtk_widget_show(GTK_WIDGET(dicewidgets[1]));
	gtk_widget_show(GTK_WIDGET(diceboxes[0]));
	gtk_widget_show(GTK_WIDGET(diceboxes[1]));

  mytext=add_text_box(100,100,400,100);
  for (i=1; i<=NoOfPlayers; i++) {
    loctxt[i]=add_text_box( 100, 350+(50*i), 400, 20);
    cashtxt[i]=add_text_box(20+(80*i), 200, 80, 20);
  }

  gtk_widget_show (window);       
  if (MyPlayerNum==Master) {
//    for (i=2; i<=NoOfPlayers; i++)
      interrupt=add_input(i);
	//gdk_input_add(mysocket[2], GDK_INPUT_READ, receive_structured_packet, 0);
	play_game();
  }
  else
      interrupt=add_input(1);
      //interrupt=gdk_input_add(mysocket[1], GDK_INPUT_READ, receive_structured_packet, 0);
  gtk_main ();     

 
  return;
}

